/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/06
 * Description        : SPI0ʾ Master/Slave ģʽշ
 *******************************************************************************/

#include "CH57x_common.h"






__attribute__((aligned(4))) UINT8 spiBuff[100];
__attribute__((aligned(4))) UINT8 spiBuffrev[16];
 volatile UINT8 j=0;
 volatile UINT8 k=1;
 volatile UINT8 lastdata;
 volatile uint8_t spi_out;


void DebugInit( void )
{
    GPIOA_SetBits( GPIO_Pin_9 );
    GPIOA_ModeCfg( GPIO_Pin_8, GPIO_ModeIN_PU );
    GPIOA_ModeCfg( GPIO_Pin_9, GPIO_ModeOut_PP_5mA );
    UART1_DefInit();
    UART1_BaudRateCfg( 5e5 );
}

void hex_dump(uint8_t *data,uint32_t length) {
    for(uint32_t i=0;i<length;i++) {
        PRINT("%02x ",data[i]);
    }
    PRINT("\r\n");
}



int main()
{
    UINT8 i;

    SetSysClock( CLK_SOURCE_PLL_60MHz );

    /* ôڵ */
    DebugInit();
    PRINT( "Start @ChipID=%02X\n", R8_CHIP_ID );

    GPIOB_ResetBits(GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3);
    GPIOB_ModeCfg(GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3, GPIO_ModeOut_PP_5mA);



    PRINT( "1.spi0 slave mode \n");
    GPIOA_ModeCfg(GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15, GPIO_ModeIN_PU);
    SPI0_SlaveInit();



    R8_SPI0_CTRL_MOD |= RB_SPI_FIFO_DIR|R8_SPI0_CTRL_MOD;
    R8_SPI0_CTRL_MOD &= ~RB_SPI_FIFO_DIR; //fifo out
    spi_out = 0;
    SPI0_ITCfg(ENABLE,RB_SPI_IE_BYTE_END); //use byte interrupt

    PFIC_EnableIRQ( SPI0_IRQn );


    while( 1 ){

    }

}


//for spi ->uart sync test
#define UART_PUT_TEST(X)    (R8_UART1_THR=(X))

__attribute__((interrupt("WCH-Interrupt-fast")))
__attribute__((section(".highcode")))
void SPI0_IRQHandler (void)
{
    //test io
    GPIOB_SetBits(GPIO_Pin_0);

    if(R8_SPI0_RUN_FLAG & RB_SPI_SLV_CMD_ACT) { //first data
        j = 0;
        spiBuffrev[j] = R8_SPI0_BUFFER;
        UART_PUT_TEST(spiBuffrev[j]);
        if(!(spiBuffrev[j]&0x80)) {         //cmd read
            spi_out = 1;
            UART_PUT_TEST(8);
            R8_SPI0_FIFO = 8;               //read lenth ,should write more data here, 8 bytes hareware fifo
            j++;
        }else{                              //cmd write
            spi_out = 0;
        }
    }else{
        if(spi_out) {
            R8_SPI0_FIFO = j;               //read data
            UART_PUT_TEST(j);

        }else{
                                            //write data
            spiBuffrev[j] = R8_SPI0_BUFFER;
            UART_PUT_TEST(spiBuffrev[j]);
        }
        j++;
    }
    GPIOB_ResetBits(GPIO_Pin_0);
    R8_SPI0_INT_FLAG |= 0xff;
}

